<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Network</title>
    <script type="text/javascript" src="vis-network.min.js"></script>
<!--     <script type="text/javascript" src="ashtanga.js"></script> -->
<!--     <script type="text/javascript" src="tarkadeepika.js"></script> -->
    <script type="text/javascript" src="mahabhashyam.js"></script>
    <style type="text/css">
      #mynetwork {
        width: 80dvw;
        height: 80dvh;
        border: 1px solid lightgray;
      }
    </style>
  </head>
  <body>
    <label for="clusterSize">Cluster Size</label>
    <select id="clusterSize" onchange="updateParams()">
      <option value="30">30</option>
      <option value="50" selected>50</option>
      <option value="100">100</option>
      <option value="200">200</option>
      <option value="500">500</option>
    </select>
    <label for="maxFreeNodes">Display Nodes</label>
    <select id="maxFreeNodes" onchange="updateParams()">
      <option value="100">100</option>
      <option value="200" selected>200</option>
      <option value="500">500</option>
      <option value="1000">1000</option>
    </select>
<!--     <button onclick="cluster1()">Cluster</button> -->

    <div id="mynetwork"></div>
    <script type="text/javascript">
      var nodes = result.entities;
      var edges = result.relations;

      var container = document.getElementById("mynetwork");
      var data = {
        nodes: nodes,
        edges: edges,
      };
      let physics_conf = {
        enabled: true,
        maxVelocity: 40,
        minVelocity: 15,
        solver: 'forceAtlas2Based',
        timestep: 0.8,
        stabilization: {
          enabled: true,
//           iterations: 5,
//           updateInterval: 5,
        },
      };
      var options = {};
      options['physics'] = physics_conf;

      /* Clustering logic */
      let openClusterId = 0;
      let freeNodes = [];
      let mustOpenNodes = [];
      let clusterSize = 30;
      let maxFreeNodes = 100;
      let cid = 1;
      nc = 0;

      function updateParams() {
        clusterSize = parseInt(document.getElementById("clusterSize").value);
        maxFreeNodes = parseInt(document.getElementById("maxFreeNodes").value);

        cid = 1;
        for(var i=0; i < data.nodes.length; i++) {
          if ((i+1) % clusterSize == 0) { cid++; }
          data.nodes[i].cid = cid;
        }

        try {
          cluster1();
          for(var i=0; i < nc; i++) {
            if (network.body.nodeIndices.length > maxFreeNodes+nc) break;
            try {
                network.openCluster("cluster_"+i);
              }
            catch {}
          }
        }
        catch {}
      }
      updateParams();

      function cluster1() {
//         network.redraw();

        nc = Math.floor((nodes.length-maxFreeNodes) / clusterSize) + 1;
        for(var i=0; i < nc; i++) {
          clusterOptionsByData = {
              joinCondition:function(nodeOptions) {
                  if (mustOpenNodes.includes(nodeOptions)) {return false}
                  return nodeOptions.cid === i;
              },
              clusterNodeProperties: { id: 'cluster_' + i, borderWidth: 3, shape: 'dot', label: `cluster_${i} >> ${clusterSize}n`, group: 'cluster_1', font: {size: '24'}, size: 25, color: '#ff9933' }
          }
          network.clustering.cluster(clusterOptionsByData);
        }

//         network.redraw();
      }

      function clusterNone() {
        for(var i=0; i < network.body.nodeIndices.length; i++) {
          if (network.isCluster(network.body.nodeIndices[i])) { network.openCluster(network.body.nodeIndices[i]); }
        }
      }

      network = new vis.Network(container, data, options);
      network.on("click", function (params) {
        if (params.nodes.length == 1) {
          if (network.isCluster(params.nodes[0]) == true) {
            mustOpenNodes = network.getNodesInCluster(params.nodes[0]);
            updateParams();
            network.openCluster(params.nodes[0]);
          }
        }
      });
      cluster1();
      network.fit();
    </script>
  </body>
</html>
